Program PalFX;
{ PalFX.pas - Palette Effects for Turbo Pascal Version 1.0

	Created by FJTC for the e Software GP in 5/16/1997
	Last Update: 5/16/1997

==============================================================================
Distribution Note:

	It's a freeware, you can use and modify it but you can not sell it.

==============================================================================
Use it by your own risk:

	I'll not assume any damage that the contents of this file could cause in
your computer, brain or anything related you.

==============================================================================
Notes:

	This file will only work in DOS programs only.

==============================================================================
Contact us at:

	Home page:
		http://www.icmsc.sc.usp.br/~andreeta/e-Software
		http://www.icmsc.sc.uscp.br/~chino/e-Software
	E-Mail:
		chino@icmsc.sc.usp.br
}
Uses Pal256, CRT;

Procedure InitMode13; Assembler;
{Starts Graphic mode 13}
	Asm
		Xor ah, ah
		Mov al, 13h
		Int 10h
	End;{InitMode13}

Procedure InitTextMode; Assembler;
{Restore Text mode}
	Asm
		Xor ah, ah
		Mov al, 3h
		Int 10h
	End;{InitTextMode}

Procedure Pset(X,Y: Integer; Color: Byte);
{Plot a Pixel - It's too poor}
	Begin
		Mem[$A000:Y * 320 + X] := Color;
	End;{Pset}

Procedure DrawSample;
{Draw Example}
	Var
		X: Integer;
		Y: Integer;
	Begin
		For X := 0 to 255 do
			For Y := 0 to 50 do
				Begin
					Pset(X, Y, X);
				End;{For}
		{End For}
		For X := 0 to 255 do
			For Y := 51 to 151 do
				Begin
					Pset(X, Y, 255 - X);
				End;{For}
		{End For}
		For X := 0 to 255 do
			For Y := 152 to 199 do
				Begin
					Pset(X, Y, X);
				End;{For}
		{End For}
	End;{DrawSample}

Procedure RotatePalette(Var Pal: Palette256);
{Make Palette Rotation Effect}
	Var
		W: Integer;
		Temp: RGB;
	Begin
		Temp := Pal[1];
		For W :=1 to 254 do
			Pal[W] := Pal[W + 1];
		{End For}
		Pal[255] := Temp;
	End;{RotatePalette}

Var
	Pal: Palette256;{Palette for Effect}
Begin
	InitMode13;{Start Graphic Mode}
	DrawSample;{Draw a simple Hue}
	GetPalette(Pal);{Get BIOS Palette}
	Repeat
		RotatePalette(Pal); {Rotate Palette}
		SetPalette(Pal); {Set New palette}
		Delay(100); {Remove it for Full Speed}
	Until Keypressed;
	InitTextMode;{Close Graphic Mode}
End.